//
//      SGRListboxControl.cpp
//
//      This source code was automatically
//      generated by SophiaFramework 4.1.5
//

#include "SGRListboxControl.hpp"
#include "pself2.hpp"

// RXgN^
SGRListboxControl::SGRListboxControl(SFRResponderPtr responder, SFXRectangleConstRef rect) static_throws : SFRControl(responder, rect, SFXMargin(2, 2, 2, 2), SFMRESPONDERFILTER(LISTBOXCONTROL, BEHAVIOR_LISTBOXCONTROL), ATTRIBUTE_LISTBOXCONTROL)
{
    SFXRectangle temp;

	// L[ nh̓o^
	if (static_try()) static_throw(RegisterHandler(SFEVT_KEY, HANDLER_AFTER, HANDLER_FUNCTION(OnKey)));
	if (!static_try()) return; 

	// x[X nh̓o^
    if (static_try()) static_throw(RegisterHandler(SREVT_RESPONDER_RENDER, SRP16_RENDER_BASE, HANDLER_BEFORE, HANDLER_FUNCTION(OnBase)));
    if (!static_try()) return;     
       
	// `nh̓o^
	if (static_try()) static_throw(RegisterHandler(SREVT_RESPONDER_RENDER, SRP16_RENDER_CONTENT, HANDLER_BEFORE, HANDLER_FUNCTION(OnContent)));
    if (!static_try()) return;   
	
	// W[ nh̓o^
	if (static_try()) static_throw(RegisterHandler(SFEVT_APP_RESUME, HANDLER_BEFORE, HANDLER_FUNCTION(OnResume)));
    if (!static_try()) return;   

	// TXyh nh̓o^
	if (static_try()) static_throw(RegisterHandler(SFEVT_APP_SUSPEND, HANDLER_AFTER, HANDLER_FUNCTION(OnSuspend)));
    if (!static_try()) return;

	// x[ẌeX|_̍WnŎ擾
	temp = GetBaseBound();
	// x[Ẍ 2 sNZAc 2 sNZk߂
	temp.Deflate(2, 2);
    
	// ϐ̏
	_limit = 0;   
	_select = 0;   
	_offset = 0;                       
	_speed = DEFAULT_SPEED;                           
	_height = SFXGraphics::GetFontHeight(AEE_FONT_NORMAL) + ITEM_MARGIN;
	_field = temp.GetHeight() / _height;
	_delta = 0;
	_interval = DEFAULT_INTERVAL;
	_firstinterval = DEFAULT_FIRSTINTERVAL;
	_drawWidth = temp.GetWidth();

	// x[Ẍ̍ݒ
	temp.SetHeight(_field * _height);
	// x[Ẍ 2 sNZAc 2 sNZg傷
	temp.Deflate(-2, -2);

	// x[Ẍړ
	temp.Offset(SFXGrid((GetBaseBound().GetSize() - temp.GetSize()) / 2));

	// x[Ẍ̐ݒ
	SetBaseBound(temp);

	// ^C}[̓o^ɕKvȏݒ肷
	_timer.Set(CALLBACK_FUNCTION(TimerCallback));

    return;
}

// fXgN^
SGRListboxControl::~SGRListboxControl(Void)
{
	// ^C}[̓o^
    StopTimer();
    Clear();
    return;
}

// Xg{bNXǉ
SFCError SGRListboxControl::Append(SFXAnsiStringConstRef item)
{
    SFXAnsiStringPtr string;
    SFCError error(SFERR_NO_ERROR);

	// item 
    if ((string = ::new SFXAnsiString(item)) == null) return SFERR_NO_MEMORY;
    
	// _item XgɒǉłȂ
	if (_item.Append(string) != SFERR_NO_ERROR) {
		::delete string;
		return SFERR_FAILED;
	}
            
	++_limit;
    
	// ̓^C}[N
	if (_item.GetSize() == 1) {
		// ^C}[N
		StartTimer();           
	}
			
	// Op`̈ʒuĐݒ肷    
	RefreshDelta();
	
	// ĕ`悷
	InvalidateContent();

    return error;
}

// Xg{bNX폜
Void SGRListboxControl::Remove(SInt16 index)
{
	// _item XgłȂꍇ
    if (!_item.IsEmpty()) {

		// ^C}[̓o^
		StopTimer();

		// index  0̏ꍇ
        if (index < 0) {
            index = 0;
        }
		// _item Xg̐ index 菭Ȃꍇ
        else if (index >= _item.GetSize()) {
            index = static_cast<SInt16>(_item.GetSize()) - 1;
        }
		// _item Xg폜
		::delete _item[index];
        _item.Remove(index);

		--_limit;
        
		// index  _select ꍇ
		if (index < _select) {
            --_select;
        }
		// _item Xg̐ _select ꍇ
        else if (_select >= _item.GetSize()) {
            if (_select > 0) {
                --_select;
            }
            if (_delta > 0) {
                --_delta;
            }
        }

		// Op`̈ʒuĐݒ肷
        RefreshDelta();
		// ^C}[ēo^
        RestartTimer();

		// ĕ`悷
        InvalidateContent();
    }
}

// Xg{bNX
Void SGRListboxControl::Clear(Void)
{
	// 񋓎q̎擾
    SFXArray<SFXAnsiStringPtr>::Enumerator it(_item.GetFirstEnumerator());

	// 񋓎qLł邩肷
    if (it.IsValid()) {
		// ̗vf邩肷
        while (it.HasNext()) {
			// Xg̍폜
            ::delete it.GetNext();
        }
    }
	//ϐ̏
    _item.Clear();
    _limit = 0;
    _select = 0;
	// ^C}[̓o^
    StopTimer();
	// Op`̈ʒuĐݒ肷
    RefreshDelta();
	// ĕ`悷
    InvalidateContent();
    return;
}

// L[ nh
HANDLER_IMPLEMENT_BOOLEVENT(SGRListboxControl, OnKey, event)
{
    Bool result(true);

    switch (event.GetP16()) {
        case AVK_SELECT:	// ZNg L[
			// Xǧ 1ȏ゠ꍇ
            if (_limit > 0) {
				// Cxg𑗐M
                Invoke(SFXEvent(SREVT_CONTROL, _select, reinterpret_cast<UInt32>(this)));
            }
            break;
        case AVK_CLR:	// NA L[
			// ^[Qbg tOݒ肷
            SetStatusTarget(false);
			// Cxg𑗐M
            Invoke(SFXEvent(SREVT_CONTROL, SRP16_ESCAPE, reinterpret_cast<UInt32>(this)));
            break;
        case AVK_UP:	// L[
            if (_select > 0) {
                --_select;
				// ^C}[ēo^
                RestartTimer();
				// Op`̈ʒuĐݒ肷
                RefreshDelta();
                // ĕ`悷
				InvalidateContent();
            }
            break;
        case AVK_DOWN:	// L[
            if (_select < _limit - 1) {
                ++_select;
				// ^C}[ēo^
                RestartTimer();
				// Op`̈ʒuĐݒ肷
                RefreshDelta();
				// ĕ`悷
                InvalidateContent();
            }
            break;
        default:
            result = false;
            break;
    }
    return result;
}

// x[X nh
HANDLER_IMPLEMENT_VOIDRENDER(SGRListboxControl, OnBase, graphics)
{
    SFXRectangle rect(GetBaseWorld());
    SFXBevelColor frameRgb(SFXRGBColor(0xAA, 0xAA, 0xAA, 0x00), SFXRGBColor(0xFF, 0xFF, 0xFF, 0x00), SFXRGBColor(0xFF, 0xFF, 0xFF, 0x00));

	// X|_̉\ȏꍇ
    if (GetInheritEnable()) {
		// ̘̂g`悷
        graphics->DrawBevelRectangle(rect, frameRgb);
		// ` 1 sNZAc 1 sNZk߂
        rect.Deflate(1, 1);
		// ``悷
        graphics->DrawRectangle(rect, SFXRGBColor(0x00, 0x00, 0x00, 0x00));
    }
    else {
		// `̓hԂ
        graphics->FillRectangle(rect, frameRgb.GetBase());
		// ` 1 sNZAc 1 sNZk߂
        rect.Deflate(1, 1);
		// ``悷
        graphics->DrawRectangle(rect, SFXRGBColor(0x66, 0x66, 0x66, 0x00));
    }
    return;
}

// `nh
HANDLER_IMPLEMENT_VOIDRENDER(SGRListboxControl, OnContent, graphics)
{
    SFXRectangle rect(GetContentWorld());
    SFXRectangle temp;
    SFXRGBColor blue(ITEM_BLUE_COLOR);
    SInt16 r0;
    Bool next;
    Bool previous;

	// X|_̉s\ȏꍇ
    if (!GetInheritEnable()) {
		// RGB ̐FύX
        blue.AddRGB(0x11);
    }

    next = (_delta + _field < _limit);
    previous = (_delta > 0);

    // `̍ݒ肷
	rect.SetHeight(_height);
    
	// Xg
	for (r0 = 0; r0 < _field; ++r0) {
		// `̓hԂ
        graphics->FillRectangle(rect, ((r0 + _delta) % 2 == 0) ? SFXRGBColor(0xFF, 0xFF, 0xFF, 0x00) : blue);
        if (r0 + _delta < _limit) {
            temp = rect;
			// IĂ郊Xg̏ꍇ
            if (r0 + _delta == _select) {
				// X|_\  tH[JX  ^[QbgԂ̏ꍇ
                if (GetInheritEnable() && GetInheritFocus() && GetInheritTarget()) {
					// `̓hԂ
                    graphics->FillRectangle(temp, SFXRGBColor(ITEM_GREEN_COLOR));
                }
            }
			// ACe`悷
            DrawItem(graphics, temp, r0 + _delta, next && (r0 == _field - 1), previous && (r0 == 0), r0 + _delta == _select ? _offset : 0);
        }
		// `ړ
        rect.Offset(0, rect.GetHeight());
    }
    return;
}

// W[ nh
HANDLER_IMPLEMENT_VOIDRESUME(SGRListboxControl, OnResume, environment)
{
    unused(environment);

    StartTimer();
    return;
}

// TXyh nh
HANDLER_IMPLEMENT_VOIDSUSPEND(SGRListboxControl, OnSuspend, reason, info)
{
    unused(reason);
    unused(info);

    StopTimer();
    return;
}

// Op`̈ʒuĐݒ肷
Void SGRListboxControl::RefreshDelta(Void)
{
    if (_select < _delta) {
        _delta = _select;
    }
    else if (_select >= _delta + _field) {
        _delta = _select - _field + 1;
    }
    return;
}

// ACe`悷
Void SGRListboxControl::DrawItem(SFXGraphicsPtr graphics, SFXRectangleConstRef rect, SInt16 index, Bool next, Bool previous, SInt16 offset)
{
    SFXRectangle text(rect);
    SFXGrid grid;
    SFXRectangle icon;
    SInt16 temp;

	// ` 4 sNZAc 1 sNZk߂
    text.Deflate(4, 1);

    if (next || previous) {
        icon = text;
		// `k߂
        icon.Deflate(icon.GetWidth() - icon.GetHeight(), 0, -1, 0);
        temp = 0;

		// previous tO true ̏ꍇ
        if (previous) {
			// Op``悷
            temp = DrawTriangle(graphics, icon, false, SFXRGBColor(0x00, 0x00, 0x00, 0x00));
        }
		// next tO true ̏ꍇ
        if (next) {
			// Op``悷
            temp = DrawTriangle(graphics, icon, true, SFXRGBColor(0x00, 0x00, 0x00, 0x00));
        }
		// `k߂
        text.Deflate(0, 0, temp, 0);
    }
	// W擾
    grid = text.GetOrigin();
	// X WZ
    grid.SubX(offset);
	// ACe`悷
    graphics->DrawText(*_item.Get(index), grid, text, SFXRGBColor(0x00, 0x00, 0x00, 0x00), IDF_ALIGN_LEFT);

    return;
}

// Op``悷
SInt16 SGRListboxControl::DrawTriangle(SFXGraphicsPtr graphics, SFXRectangleConstRef rect, Bool figure, SFXRGBColorConstRef color)
{
    SFXTriangle triangle;
    SFXPixel point;
    SFXSize size;

	// TCY̕ƍݒ肷
    size.SetHeight(rect.GetHeight() / 4);
    size.SetWidth(size.GetHeight() * 2 - 1);

	// sNZݒ肷
    point.Set(rect.GetX() + rect.GetWidth() - size.GetHeight() - size.GetWidth() + 1, rect.GetY() + ((figure) ? (rect.GetHeight() - size.GetWidth()) : (size.GetWidth() - 1)));
    
	// Op`̑꒸_ݒ肷
	triangle.SetFirst(point);
	// sNZړ
    point.Offset((size.GetWidth() - 1) / 2, (figure) ? (size.GetHeight() - 1) : (1 - size.GetHeight()));
	// Op`̑񒸓_ݒ肷   
	triangle.SetSecond(point);
	// sNZړ
    point.Offset((size.GetWidth() - 1) / 2, (figure) ? (1 - size.GetHeight()) : (size.GetHeight() - 1));
    // Op`̑O_ݒ肷
	triangle.SetThird(point);
	// OiF color ɐݒ肷
    graphics->SetForeColor(color);
	// hԂFݒ肷
    graphics->SetFillColor(color);
	// hԂ[hݒ肷
    graphics->SetFillMode(true);
	// Op``悷
    graphics->DrawTriangle(triangle);
	// TCYԂ
    return size.GetWidth() + (size.GetHeight() - 1) * 2;
}

// R[obN֐
CALLBACK_IMPLEMENT_SFXTIMER(SGRListboxControl, TimerCallback)
{
    SInt16 textWidth;

	if(_item.GetSize() > 0){ 
		textWidth = SFXGraphics::MeasureText(AEE_FONT_NORMAL, *_item.Get(_select));
		if (textWidth > _drawWidth) {
			_offset += _speed;
		}
		if (_offset > textWidth) {
			_offset =  -_drawWidth;
		}
	}
	// ĕ`悷
    InvalidateContent();
	// Cxg𑗐M
    SFRApplication::GetInstance()->Invoke(SFXEvent(SREVT_RESPONDER_RENDER, SRP16_RENDER_INVOKE, false));
    // ^C}[o^
	_timer.Schedule(_interval);
}

// ^C}[o^
Void SGRListboxControl::StartTimer(Void)
{
	// ^C}[o^
    _timer.Schedule(_firstinterval);
}

// ^C}[̓o^
Void SGRListboxControl::StopTimer(Void)
{
    _offset = 0;
	// o^ꂽ^C}[LZ
    _timer.Cancel();
}

// ^C}[ēo^
Void SGRListboxControl::RestartTimer(Void)
{
    _offset = 0;
    // ēo^邱ƂŁAÕ^C}[͎ŃLZ
    _timer.Schedule(_firstinterval);
}
